#include <iostream>
#include <iterator>
#include "faf.h"

using namespace std;

int main(int argc, char **argv)
{
  set<unsigned> builds, bcfiles;
  set<unsigned>::const_iterator ii, iii;
  string filename;

  if (argc != 2)
  {
    cerr << "Usage: " << argv[0] << " " << "ABRT_Server_URL" << endl;
    cerr << "Example:" << endl << argv[0] << " https://retrace.fedoraproject.org/faf/" << endl;
    return 1;
  }

  FafClient fc(argv[1]);

  bool success = fc.getLlvmBuilds(builds);
  if (!success)
  {
    cerr << fc.getError() << endl;
    return 1;
  }

  for (ii = builds.begin(); ii != builds.end(); ++ii)
  {
    cout << "LlvmBuild #" << *ii << endl;
    success = fc.getBcFiles(*ii, bcfiles);
    if (!success)
    {
      cout << "  " << fc.getError() << endl;
      continue;
    }

    if (bcfiles.size() == 0)
    {
      cout << "  No LlvmBcFile found" << endl << endl;
      continue;
    }

    for (iii = bcfiles.begin(); iii != bcfiles.end(); ++iii)
    {
      string msg = fc.getBcFileName(*iii, filename) ? filename : fc.getError();
      cout << "  LlvmBcFile #" << *iii << ": " << msg << endl;
    }

    bcfiles.clear();
    cout << endl;
  }

  return 0;
}
