#include <set>
#include <string>
#include <ostream>

#ifndef _FAF_H
#define _FAF_H

class FafClient
{
  private:
    std::string baseUrl;
    std::string errorMsg;
    void setError(std::string errorMsg);
    bool downloadToStream(std::string url, std::ostream &dest);

  public:
    FafClient(std::string baseUrl);
    std::string getError();
    bool getLlvmBuilds(std::set<unsigned> &dest);
    bool getBcFiles(int llvmBuildId, std::set<unsigned> &dest);
    bool getBcFileName(int bcFileId, std::string &dest);
    bool downloadBcFile(int bcFileId, std::ostream &dest);
};

#endif
